/*
 * Delays.c
 *
 *  Created on: Oct 28, 2023
 *      Author: martin
 */
/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "Delays.h"

void RTC_Delay(uint8_t delay, uint8_t prescaler)

{   
    RTCSC = prescaler; //can be 1ms, 2ms , 4ms, 8ms, 16ms or 32ms.  
	RTCMOD=0xFF; //Start RTC. 
	while(RTCCNT < delay);
	RTCMOD =0x00; //Clear RTC.
}

void Delay_50us(void) {
	
	asm nop;
	asm nop;
	
	asm { 
		 CLR $82
		 MOV #$33, $82
	    b:
	      NOP
	      DBNZ $82, b
	  }
}
void Delay_25us(void) {
	
	 asm { 
		 CLR $82
		 MOV #$18, $82
	    b:
	      NOP
	      DBNZ $82, b
	  }
}	 
void Delay_10us(void) {
	
	 asm nop;
	 
	 asm { 
		 CLR $82
		 MOV #$7, $82
	    b:
	      NOP
	      DBNZ $82, b
	  }
}

void Delay_5us(void) {
	
	asm nop;
	asm nop;
	asm nop;
	asm nop;
	asm nop;
	
	asm { 
		 CLR $82
		 MOV #$1, $82
	    b:
	      NOP
	      DBNZ $82, b
	  }
}

void Delay_3us(void) {	
	 asm { 
		  NOP
		  NOP
		  NOP
  	      NOP
	  }
}

