/* ###################################################################
**     Filename    : main.c
**     Project     : example_12
**     Processor   : MC9S08SE8CWL
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-11-08, 03:34, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "PTB.h"
#include "Cap1.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#include "TM1637.h"
#include "Delays.h"

#define PORTB_D0 PTBD_PTBD0
#define PORTC_D1 PTCD_PTCD1
#define PORTB PTBD

//PTA6 is configured as a capture input of the timer1

void HCSR04_TRIGGER ()
{
  PORTB_D0=1;
  Delay_10us();
  PORTB_D0=0;
}
 void main(void)
{
  /* Write your local variable definition here */
	long Distancia=0;
	char scale=0, e0=0; 
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  /* For example: for(;;) { } */
  COPFree_Init();
  PTB_Init();
  PTBDD_PTBDD1=0;
  PTCDD_PTCDD1=0;
  TM1637_Init();
  TM1637_DisplayDecimal(0,0,ENABLE_ZEROS);
  RTC_Delay(250,_4ms);// 1 seg. 
  Cap1_Reset();
 
  for(;;) {
	       if(PORTC_D1==0) {
	    	   RTC_Delay(5,_1ms);
	  		if(PORTC_D1==0)e0 =1, RTC_Delay(5,_1ms);
	  	   }
	  	  if((PORTC_D1==1)&& (e0==1))scale++, e0=0; 
	  
	      HCSR04_TRIGGER();
	      while((PORTB&(1<<1))==0);//PTB1 serves as flag 
	      Cap1_Reset();
	      while(PORTB&(1<<1));
	      Distancia=(TPM1C0V/58); //The number 58 is a manufacturer constant.
	      
	      //for distances >1129 mm.(65535/58) = 1129mm
	      if(scale==1)Distancia=1129+Distancia;//Distancia=100+((65535+TPM1C0V)/58);
	      //for distances >2258 mm.
	      if(scale==2)Distancia=100+(2*((65535+TPM1C0V)/58));
	      //for distances >3387 mm.
	      if(scale==3)Distancia=100+(3*((65535+TPM1C0V)/58));
	      
	      if(scale>3) scale=0;
	      
	      TM1637_DisplayDecimal(Distancia,0,DISABLE_ZEROS);//The distance is expressed in millimeters. 
	      RTC_Delay(250,_2ms);// 500ms
	  }
  

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
